## root-system 5.34.30

=== CMakeLists.txt ===
#---Check if cmake has the required version-----------------------------------------------------
cmake_minimum_required(VERSION 2.8.8 FATAL_ERROR)
cmake_policy(SET CMP0005 NEW)
#---Set name of the project to "ROOT". Has to be done after check of cmake version--------------
project(ROOT)
set(IntegratedBuild ON)

#---Set pathes where to put the libraries, executables and headers------------------------------
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(ROOTSYS ${CMAKE_BINARY_DIR})
set(HEADER_OUTPUT_PATH ${CMAKE_BINARY_DIR}/include)
set(ROOT_INCLUDE_DIR ${HEADER_OUTPUT_PATH})

#---Set the library version in the main CMakeLists.txt------------------------------------------
file(READ ${CMAKE_SOURCE_DIR}/build/version_number versionstr)
string(STRIP ${versionstr} versionstr)
string(REGEX REPLACE "([0-9]+)[.][0-9]+[/][0-9]+" "\\1" ROOT_MAJOR_VERSION ${versionstr})
string(REGEX REPLACE "[0-9]+[.]([0-9]+)[/][0-9]+" "\\1" ROOT_MINOR_VERSION ${versionstr})
string(REGEX REPLACE "[0-9]+[.][0-9]+[/]([0-9]+)" "\\1" ROOT_PATCH_VERSION ${versionstr})
set(ROOT_VERSION "${ROOT_MAJOR_VERSION}.${ROOT_MINOR_VERSION}.${ROOT_PATCH_VERSION}")

#---Where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked-------------
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)

#---Enable Folders in IDE like Visual Studio----------------------------------------------------
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

#---Load some basic macros which are needed later for the confiuration and build----------------
include(RootBuildOptions)
include(RootNewMacros)
include(CheckCompiler)
include(MacroEnsureVersion)

#---Enable CTest package -----------------------------------------------------------------------
#include(CTest)
if(testing)
  enable_testing()
endif()

#---Check if the user wants to build the project in the source directory------------------------
ROOT_CHECK_OUT_OF_SOURCE_BUILD()

#---Here we look for installed software and switch on and of the different build options--------
include(SearchInstalledSoftware)
ROOT_SHOW_OPTIONS()

#---Populate the configure arguments returned by 'root-config --config'-------------------------
get_cmake_property(variables CACHE_VARIABLES)
foreach(var ${variables})
  if((var MATCHES "_(LIBRARIES|LIBRARY|INCLUDE)") AND
     (NOT ${${var}} STREQUAL "") AND
     (NOT ${var} MATCHES "NOTFOUND"))
    if (var MATCHES "^QT_")
      # filter out the very long list of Qt libraries and include dirs
      if (var MATCHES "(QT_LIBRARY_DIR|QT_QTCORE_INCLUDE_DIR)")
        set(ROOT_CONFIGARGS "${ROOT_CONFIGARGS}${var}=${${var}} ")
      endif()
    else()
      if ((NOT var MATCHES "_(DOCS|TESTS|INSTALL)") AND (NOT var MATCHES "^_"))
        set(ROOT_CONFIGARGS "${ROOT_CONFIGARGS}${var}=${${var}} ")
      endif()
    endif()
  endif()
endforeach()

#---Move (copy) the headers and other directories to binary tree---------------------------------
set(stamp_file ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/move_artifacts.stamp)
add_custom_command(OUTPUT ${stamp_file}
                   COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_SOURCE_DIR}/etc ${CMAKE_BINARY_DIR}/etc
                   COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_SOURCE_DIR}/icons ${CMAKE_BINARY_DIR}/icons
                   COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_SOURCE_DIR}/fonts ${CMAKE_BINARY_DIR}/fonts
                   COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_SOURCE_DIR}/macros ${CMAKE_BINARY_DIR}/macros
                   COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_SOURCE_DIR}/tutorials ${CMAKE_BINARY_DIR}/tutorials
                   COMMAND ${CMAKE_COMMAND} -E touch ${stamp_file}
                   COMMENT "Moving directorties such as etc, icons, fonts, etc. to build area")
add_custom_target(move_headers DEPENDS ${stamp_file}
                               COMMAND ${CMAKE_COMMAND} -DPREFIX=${CMAKE_BINARY_DIR}
                                                        -DCOMPONENTS="headers"
                                                        -P ${CMAKE_SOURCE_DIR}/cmake/scripts/local_install.cmake)
include_directories(${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_INCLUDEDIR})

#---Recurse into the given subdirectories.  This does not actually cause another cmake executable
#  to run. The same process will walk through the project's entire directory structure.
add_subdirectory (cint)
add_subdirectory (core)
add_subdirectory (build)
add_subdirectory (math)
add_subdirectory (hist)
add_subdirectory (tree)
add_subdirectory (io)
add_subdirectory (net)
add_subdirectory (graf2d)
add_subdirectory (graf3d)
add_subdirectory (gui)
add_subdirectory (proof)
add_subdirectory (html)
add_subdirectory (montecarlo)
add_subdirectory (geom)
add_subdirectory (rootx)
add_subdirectory (misc)
add_subdirectory (main)
add_subdirectory (bindings)
add_subdirectory (sql)
if(tmva)
  add_subdirectory(tmva)
endif()
if(roofit)
  add_subdirectory(roofit)
endif()

ROOT_ADD_TEST_SUBDIRECTORY(test)
ROOT_ADD_TEST_SUBDIRECTORY(tutorials)

#---hsimple.root---------(use the executable for clearer dependencies and proper return code)---
if(NOT gnuinstall)   # TODO hsimple.root for gnuinstall
  add_custom_target(hsimple ALL DEPENDS hsimple.root)
  ROOT_EXECUTABLE(hsimple.exe test/hsimple.cxx NOINSTALL LIBRARIES RIO Tree Hist)
  if(WIN32)
    add_custom_command(OUTPUT hsimple.root
                       COMMAND set PATH=${CMAKE_RUNTIME_OUTPUT_DIRECTORY};$ENV{${ld_library_path}} && $<TARGET_FILE:hsimple.exe>)
  else()
    add_custom_command(OUTPUT hsimple.root
                       COMMAND ${ld_library_path}=${CMAKE_LIBRARY_OUTPUT_DIRECTORY}:$ENV{${ld_library_path}} $<TARGET_FILE:hsimple.exe>)
  endif()
  install(FILES ${CMAKE_BINARY_DIR}/hsimple.root DESTINATION ${CMAKE_INSTALL_TUTDIR} COMPONENT tests)
endif()

#---version--------------------------------------------------------------------------------------
add_custom_target(version COMMAND ${CMAKE_SOURCE_DIR}/build/unix/makeversion.sh ${CMAKE_BINARY_DIR}
                          WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

#---distribution commands------------------------------------------------------------------------
add_custom_target(distsrc COMMAND ${CMAKE_SOURCE_DIR}/build/unix/makedistsrc.sh ${CMAKE_SOURCE_DIR})
add_custom_target(dist COMMAND cpack --config CPackConfig.cmake)

#---Configure and install various files neded later and for clients -----------------------------
include(RootConfiguration)

#---Installation of project-wise artifacts-------------------------------------------------------
if(NOT CMAKE_SOURCE_DIR STREQUAL CMAKE_INSTALL_PREFIX)
  install(FILES LICENSE DESTINATION ${CMAKE_INSTALL_DOCDIR})
  install(DIRECTORY README DESTINATION ${CMAKE_INSTALL_DOCDIR} PATTERN ".svn" EXCLUDE)
  install(DIRECTORY etc/ DESTINATION ${CMAKE_INSTALL_SYSCONFDIR} USE_SOURCE_PERMISSIONS
                         PATTERN ".svn" EXCLUDE
                         REGEX system.rootrc EXCLUDE
                         REGEX root.mimes EXCLUDE)
  install(DIRECTORY fonts/  DESTINATION ${CMAKE_INSTALL_FONTDIR} PATTERN ".svn" EXCLUDE)
  install(DIRECTORY icons/  DESTINATION ${CMAKE_INSTALL_ICONDIR} PATTERN ".svn" EXCLUDE)
  install(DIRECTORY macros/ DESTINATION ${CMAKE_INSTALL_MACRODIR} PATTERN ".svn" EXCLUDE)
  install(DIRECTORY man/    DESTINATION ${CMAKE_INSTALL_MANDIR} PATTERN ".svn" EXCLUDE)
  install(DIRECTORY test/      DESTINATION ${CMAKE_INSTALL_TESTDIR} COMPONENT tests PATTERN ".svn" EXCLUDE)
  install(DIRECTORY tutorials/ DESTINATION ${CMAKE_INSTALL_TUTDIR} COMPONENT tests PATTERN ".svn" EXCLUDE)
  install(DIRECTORY cmake/modules DESTINATION ${CMAKE_INSTALL_CMAKEDIR} PATTERN ".svn" EXCLUDE)
  install(FILES build/misc/root.m4 DESTINATION ${CMAKE_INSTALL_ACLOCALDIR})
endif()

#---Configure Testing using CTest----------------------------------------------------------------
configure_file(${CMAKE_SOURCE_DIR}/cmake/modules/CTestCustom.cmake ${CMAKE_BINARY_DIR} COPYONLY)
if(testing)
  if(gnuinstall)
    message(FATAL_ERROR "You cannot enable to run the tests in the build directory (testing=ON) and at the same time select a GNU style installation (gnuinstall=ON). This is because the code is built with the final installation location (CMAKE_INSTALL_PREFIX) for many ancillary files (tutorials, etc, icons, macros, etc.) and these are not available before installation. Tests can be run against the installation once is completed. See the instructions in the web")
  endif()
  include(RootCTest)
endif()

#---Packaging-------------------------------------------------------------------------------------
include(RootCPack)

=== Makefile ===
# Top level Makefile for ROOT System
# Copyright (c) 2000 Rene Brun and Fons Rademakers
#
# Author: Fons Rademakers, 29/2/2000


##### Check version of GNU make #####

MAKE_VERSION_MAJOR := $(word 1,$(subst ., ,$(MAKE_VERSION)))
MAKE_VERSION_MINOR := $(shell echo $(word 2,$(subst ., ,$(MAKE_VERSION))) | \
                              sed 's/\([0-9][0-9]*\).*/\1/')
MAKE_VERSION_MAJOR ?= 0
MAKE_VERSION_MINOR ?= 0
ORDER_ := $(shell test $(MAKE_VERSION_MAJOR) -gt 3 || \
                  test $(MAKE_VERSION_MAJOR) -eq 3 && \
                  test $(MAKE_VERSION_MINOR) -ge 80 && echo '|')

##### Include path/location macros (result of ./configure) #####

include config/Makefile.config

##### Prevent propagation of user flags to autoconf        #####
##### configure  in bundled autotools projects since we    #####
##### are trying to set all compiler flags ourself and     #####
##### including them could lead to e.g. conflicting 32/64  #####
##### bit build options.
CONFIG_SITE =

##### Include compiler overrides specified via ./configure #####
##### However, if we are building packages or cleaning, we #####
##### don't include this file since it may screw up things #####
##### Included before Makefile.$ARCH only because of f77   #####
##### if case has to be processed                          #####

ifeq ($(findstring $(MAKECMDGOALS), maintainer-clean debian redhat),)
include config/Makefile.comp
endif
ifeq ($(MAKECMDGOALS),clean)
include config/Makefile.comp
endif

##### Include machine dependent macros                     #####
##### However, if we are building packages or cleaning, we #####
##### don't include this file since it may screw up things #####

ifndef ROOT_SRCDIR
$(error Please run ./configure first)
endif

ifeq ($(findstring $(MAKECMDGOALS), maintainer-clean debian redhat),)
include $(ROOT_SRCDIR)/config/Makefile.$(ARCH)
endif
ifeq ($(MAKECMDGOALS),clean)
include $(ROOT_SRCDIR)/config/Makefile.$(ARCH)
endif

##### Include compiler overrides specified via ./configure #####
##### However, if we are building packages or cleaning, we #####
##### don't include this file since it may screw up things #####

ifeq ($(findstring $(MAKECMDGOALS), maintainer-clean debian redhat),)
include config/Makefile.comp
endif
ifeq ($(MAKECMDGOALS),clean)
include config/Makefile.comp
endif

##### Include library dependencies for explicit linking #####

MAKEFILEDEP = $(ROOT_SRCDIR)/config/Makefile.depend
include $(MAKEFILEDEP)

##### Allow local macros #####

-include MyConfig.mk

##### Modules to build #####

MODULES       = build cint/cint core/metautils core/pcre core/clib core/utils \
                core/textinput core/base core/cont core/meta core/thread \
                io/io math/mathcore net/net core/zip core/lzma math/matrix \
                core/newdelete hist/hist tree/tree graf2d/freetype \
                graf2d/mathtext graf2d/graf graf2d/gpad graf3d/g3d \
                gui/gui math/minuit hist/histpainter tree/treeplayer \
                gui/ged tree/treeviewer math/physics graf2d/postscript \
                core/rint html montecarlo/eg \
                geom/geom geom/geompainter montecarlo/vmc \
                math/fumili math/mlp math/quadp net/auth gui/guibuilder io/xml \
                math/foam math/splot math/smatrix io/sql \
                geom/geombuilder hist/spectrum hist/spectrumpainter \
                gui/fitpanel proof/proof proof/proofplayer \
                gui/sessionviewer gui/guihtml gui/recorder

ifeq ($(ARCH),win32)
MODULES      += core/winnt graf2d/win32gdk
MODULES      := $(filter-out core/newdelete,$(MODULES))
SYSTEML       = $(WINNTL)
SYSTEMO       = $(WINNTO)
SYSTEMDO      = $(WINNTDO)
else
ifeq ($(ARCH),win32gcc)
MODULES      += core/unix
SYSTEML       = $(UNIXL)
SYSTEMO       = $(UNIXO)
SYSTEMDO      = $(UNIXDO)
else
ifeq ($(ARCH),win64gcc)
MODULES      += core/unix
SYSTEML       = $(UNIXL)
SYSTEMO       = $(UNIXO)
SYSTEMDO      = $(UNIXDO)
else
MODULES      += core/unix
SYSTEML       = $(UNIXL)
SYSTEMO       = $(UNIXO)
SYSTEMDO      = $(UNIXDO)
endif
endif
endif
ifeq ($(PLATFORM),ios)
MODULES      += graf2d/ios
endif
ifeq ($(BUILDVC),yes)
MODULES      += math/vc
endif
ifeq ($(BUILDVDT),yes)
MODULES      += math/vdt
endif
ifeq ($(BUILDCOCOA),yes)
MODULES      += graf2d/quartz
MODULES      += graf2d/cocoa
MODULES      += core/macosx
MODULES      += rootx
SYSTEML      += $(MACOSXL)
SYSTEMO      += $(MACOSXO)
SYSTEMDO     += $(MACOSXDO)
CORELIBEXTRA += -framework Cocoa
endif
ifeq ($(BUILDX11),yes)
MODULES      += graf2d/x11 graf2d/x11ttf graf3d/x3d rootx
endif
ifeq ($(BUILDGL),yes)
ifeq ($(BUILDFTGL),yes)
MODULES      += graf3d/ftgl
endif
ifeq ($(BUILDGLEW),yes)
MODULES      += graf3d/glew
endif
MODULES      += graf3d/gl graf3d/eve graf3d/gviz3d
endif
ifeq ($(BUILDMYSQL),yes)
MODULES      += sql/mysql
endif
ifeq ($(BUILDORACLE),yes)
MODULES      += sql/oracle
endif
ifeq ($(BUILDPGSQL),yes)
MODULES      += sql/pgsql
endif
ifeq ($(BUILDSQLITE),yes)
MODULES      += sql/sqlite
endif
ifeq ($(BUILDSAPDB),yes)
MODULES      += sql/sapdb
endif
ifeq ($(BUILDODBC),yes)
MODULES      += sql/odbc
endif
ifeq ($(BUILDRFIO),yes)
MODULES      += io/rfio
endif
ifeq ($(BUILDCASTOR),yes)
MODULES      += io/castor
endif
ifeq ($(BUILDDCAP),yes)
MODULES      += io/dcache
endif
ifeq ($(BUILDDAVIX),yes)
MODULES      += net/davix
endif
ifeq ($(BUILDGFAL),yes)
MODULES      += io/gfal
endif
ifeq ($(BUILDGLITE),yes)
MODULES      += net/glite
endif
ifeq ($(BUILDBONJOUR),yes)
MODULES      += net/bonjour
endif
ifeq ($(BUILDCHIRP),yes)
MODULES      += io/chirp
endif
ifeq ($(BUILDHDFS),yes)
MODULES      += io/hdfs
endif
ifeq ($(BUILDMEMSTAT),yes)
MODULES      += misc/memstat
endif
ifeq ($(BUILDASIMAGE),yes)
MODULES      += graf2d/asimage
ifeq ($(BUILDFITSIO),yes)
MODULES      += graf2d/fitsio
endif
endif
ifeq ($(BUILDFPYTHIA6),yes)
MODULES      += montecarlo/pythia6
endif
ifeq ($(BUILDFPYTHIA8),yes)
MODULES      += montecarlo/pythia8
endif
ifeq ($(BUILDFFTW3),yes)
MODULES      += math/fftw
endif
ifeq ($(BUILDGVIZ),yes)
MODULES      += graf2d/gviz
endif
ifeq ($(BUILDPYTHON),yes)
MODULES      += bindings/pyroot
endif
ifeq ($(BUILDRUBY),yes)
MODULES      += bindings/ruby
endif
ifeq ($(BUILDXML),yes)
MODULES      += io/xmlparser
endif
ifeq ($(BUILDQT),yes)
MODULES      += graf2d/qt gui/qtroot
endif
ifeq ($(BUILDQTGSI),yes)
MODULES      += gui/qtgsi
endif
ifeq ($(BUILDGENVECTOR),yes)
MODULES      += math/genvector
endif
ifeq ($(BUILDMATHMORE),yes)
MODULES      += math/mathmore
endif
ifeq ($(BUILDREFLEX),yes)
# put reflex right in front of CINT; CINT needs it
MODULES      := $(subst cint/cint,cint/reflex cint/cint,$(MODULES))
endif
ifeq ($(BUILDMINUIT2),yes)
MODULES      += math/minuit2
endif
ifeq ($(BUILDUNURAN),yes)
MODULES      += math/unuran
endif
ifeq ($(BUILDCLING),yes)
# put cling right behind of CINT; e.g. UTILS need it
MODULES      := $(subst cint/cint,cint/cint cint/cling,$(MODULES))
endif
ifeq ($(BUILDCINTEX),yes)
MODULES      += cint/cintex
endif
ifeq ($(BUILDROOFIT),yes)
MODULES      += roofit/roofitcore roofit/roofit roofit/roostats
ifeq ($(BUILDXML),yes)
MODULES      += roofit/histfactory
endif
endif
ifeq ($(BUILDGDML),yes)
MODULES      += geom/gdml
endif
ifeq ($(BUILDTABLE),yes)
MODULES      += misc/table
endif
ifeq ($(BUILDSRPUTIL),yes)
MODULES      += net/srputils
endif
ifeq ($(BUILDKRB5),yes)
MODULES      += net/krb5auth
endif
ifeq ($(BUILDLDAP),yes)
MODULES      += net/ldap
endif
ifeq ($(BUILDMONALISA),yes)
MODULES      += net/monalisa
endif
ifeq ($(BUILDGLOBUS),yes)
MODULES      += net/globusauth
endif
ifneq ($(F77),)
MODULES      += misc/minicern hist/hbook
endif
ifeq ($(HASXRD),yes)
MODULES      += net/netx
ifeq ($(BUILDNETXNG),yes)
MODULES      += net/netxng
endif
ifeq ($(BUILDALIEN),yes)
MODULES      += net/alien
endif
endif
ifneq ($(ARCH),win32)
MODULES      += net/rpdutils net/rootd proof/proofd proof/pq2 proof/proofbench
endif
ifeq ($(BUILDTMVA),yes)
MODULES      += tmva math/genetic
endif
ifeq ($(HASXRD),yes)
ifeq ($(BUILDXRDCLT),no)
ifeq ($(ARCH),win32)
MODULES      += proof/proofd
endif
MODULES      += proof/proofx
endif
endif
ifeq ($(BUILDAFDSMGRD),yes)
MODULES      += proof/afdsmgrd
endif
ifeq ($(BUILDHTTP),yes)
MODULES      += net/http
endif

-include MyModules.mk   # allow local modules

ifneq ($(findstring $(MAKECMDGOALS),distclean maintainer-clean),)
MODULES      += core/unix core/winnt graf2d/x11 graf2d/x11ttf \
                graf3d/gl graf3d/ftgl graf3d/glew io/rfio io/castor \
                montecarlo/pythia6 montecarlo/pythia8 misc/table \
                sql/mysql sql/pgsql sql/sqlite sql/sapdb net/srputils \
                rootx net/rootd io/dcache io/chirp hist/hbook graf2d/asimage \
                net/ldap net/krb5auth net/rpdutils net/globusauth \
                bindings/pyroot bindings/ruby io/gfal misc/minicern \
                graf2d/qt gui/qtroot gui/qtgsi net/netx net/netxng net/alien \
                proof/proofd proof/proofx proof/pq2 graf3d/x3d net/davix \
                sql/oracle io/xmlparser math/mathmore cint/reflex cint/cintex \
                tmva math/genetic io/hdfs graf2d/fitsio roofit/roofitcore \
                roofit/roofit roofit/roostats roofit/histfactory \
                math/minuit2 net/monalisa math/fftw sql/odbc math/unuran \
                geom/gdml graf3d/eve net/glite misc/memstat \
                math/genvector net/bonjour graf3d/gviz3d graf2d/gviz \
                proof/proofbench proof/afdsmgrd cint/cling graf2d/ios \
                graf2d/quartz graf2d/cocoa core/macosx net/http
MODULES      := $(sort $(MODULES))   # removes duplicates
endif

MODULES      += main   # must be last, $(ALLLIBS) must be fully formed

ifeq ($(BUILDTOOLS),yes)
MODULES       = build cint/cint core/metautils core/clib core/base core/meta \
                core/utils
endif

##### ROOT libraries #####

LPATH         = lib

ifneq ($(PLATFORM),win32)
RPATH        := -L$(LPATH)
CINTLIBS     := -lCint
NEWLIBS      := -lNew
BOOTLIBS     := -lCore -lCint
ifneq ($(ROOTDICTTYPE),cint)
BOOTLIBS     += -lCintex -lReflex
endif
ifeq ($(BUILDCLING),yes)
BOOTLIBS     += -lCling
endif
ROOTLIBS     := -lRIO -lHist -lGraf -lGraf3d -lGpad -lTree \
                -lMatrix -lNet -lThread -lMathCore $(BOOTLIBS)
RINTLIBS     := -lRint
else
CINTLIBS     := $(LPATH)/libCint.lib
NEWLIBS      := $(LPATH)/libNew.lib
BOOTLIBS     := $(LPATH)/libCore.lib $(LPATH)/libCint.lib
ifneq ($(ROOTDICTTYPE),cint)
BOOTLIBS     += $(LPATH)/libCintex.lib $(LPATH)/libReflex.lib
endif
ifeq ($(BUILDCLING),yes)
BOOTLIBS     += $(LPATH)/libCling.lib
endif
ROOTLIBS     := $(LPATH)/libRIO.lib $(LPATH)/libHist.lib \
                $(LPATH)/libGraf.lib $(LPATH)/libGraf3d.lib \
                $(LPATH)/libGpad.lib $(LPATH)/libTree.lib \
                $(LPATH)/libMatrix.lib $(LPATH)/libNet.lib \
                $(LPATH)/libThread.lib $(LPATH)/libMathCore.lib \
                $(BOOTLIBS)
RINTLIBS     := $(LPATH)/libRint.lib
endif

ROOTALIB     := $(LPATH)/libRoot.a
ROOTA        := bin/roota
PROOFSERVA   := bin/proofserva

# ROOTLIBSDEP is intended to match the content of ROOTLIBS
BOOTLIBSDEP   = $(ORDER_) $(CORELIB) $(CINTLIB)
ifneq ($(ROOTDICTTYPE),cint)
BOOTLIBSDEP  += $(CINTEXLIB) $(REFLEXLIB)
endif
ROOTLIBSDEP   = $(BOOTLIBSDEP) $(MATHCORELIB) $(IOLIB) $(NETLIB) $(HISTLIB) \
                $(GRAFLIB) $(G3DLIB) $(GPADLIB) $(TREELIB) $(MATRIXLIB)

# Force linking of not referenced libraries
ifeq ($(FORCELINK),yes)
ifeq ($(PLATFORM),aix5)
ROOTULIBS    := -Wl,-u,.G__cpp_setupG__Net      \
                -Wl,-u,.G__cpp_setupG__IO       \
                -Wl,-u,.G__cpp_setupG__Hist     \
                -Wl,-u,.G__cpp_setupG__Graf     \
                -Wl,-u,.G__cpp_setupG__G3D      \
                -Wl,-u,.G__cpp_setupG__GPad     \
                -Wl,-u,.G__cpp_setupG__Tree     \
                -Wl,-u,.G__cpp_setupG__Thread   \
                -Wl,-u,.G__cpp_setupG__Matrix
else
ifeq ($(PLATFORM),macosx)
LDSYMPREFIX  := _
endif

=== bindings/CMakeLists.txt ===
if(python)
  add_subdirectory(pyroot)
endif()
if(ruby)
  add_subdirectory(ruby)
endif()

=== cint/CMakeLists.txt ===
# To generate the dictonaries cint_tmp has to run in $ROOTSYS with the include files in $ROOTSYS/include.
# This can't be done in a separate build directory, but what can be done is
# to simulate the setup by copying some cint directories. It looks like this is enough.
execute_process(COMMAND cmake -E make_directory ${CMAKE_BINARY_DIR}/cint/cint 
                COMMAND cmake -E copy_directory ${CMAKE_SOURCE_DIR}/cint/cint/include ${CMAKE_BINARY_DIR}/cint/cint/include 
                COMMAND cmake -E copy_directory ${CMAKE_SOURCE_DIR}/cint/cint/lib ${CMAKE_BINARY_DIR}/cint/cint/lib
                COMMAND cmake -E copy_directory ${CMAKE_SOURCE_DIR}/cint/cint/stl ${CMAKE_BINARY_DIR}/cint/cint/stl )

add_subdirectory(cint)
add_subdirectory(ROOT)
if(reflex)
  add_subdirectory(reflex)
endif()
if(cintex)
  add_subdirectory(cintex)
endif()

=== core/CMakeLists.txt ===
Set(LibCore_SRCS)
Set(LibCore_INCLUDE_DIRS)
Set(LibCore_LINKDEF)

ROOT_USE_PACKAGE(core/base)
ROOT_USE_PACKAGE(core/clib)
ROOT_USE_PACKAGE(core/cont)
ROOT_USE_PACKAGE(core/meta)
ROOT_USE_PACKAGE(core/textinput)
ROOT_USE_PACKAGE(core/thread)
ROOT_USE_PACKAGE(core/unix)
ROOT_USE_PACKAGE(core/winnt)
ROOT_USE_PACKAGE(core/macosx)
ROOT_USE_PACKAGE(core/zip)
ROOT_USE_PACKAGE(core/lzma)
ROOT_USE_PACKAGE(cint/cint)


if(builtin_pcre)
  add_subdirectory(pcre)
endif()
add_subdirectory(rint)
add_subdirectory(thread)
if(NOT WIN32)
  add_subdirectory(newdelete)
endif()
add_subdirectory(clib)
add_subdirectory(cont)
add_subdirectory(textinput)
add_subdirectory(meta)
if(UNIX)
  add_subdirectory(unix)
endif()
if(WIN32)
  add_subdirectory(winnt)
endif()
if(cocoa)
  add_subdirectory(macosx)
endif()
add_subdirectory(zip)
add_subdirectory(lzma)
add_subdirectory(base)
add_subdirectory(metautils)
add_subdirectory(utils)

set(CORE_DICTIONARIES 
    ${METAUTILS_DICTIONARY}
    ${CLIB_DICTIONARY} 
    ${CONT_DICTIONARY} 
    ${TEXTINPUT_DICTIONARY} 
    ${META_DICTIONARY} 
    ${UNIX_DICTIONARY} 
    ${WINNT_DICTIONARY} 
    ${MACOSX_DICTIONARY} 
    ${BASE1_DICTIONARY} 
    ${BASE2_DICTIONARY} 
    ${BASE3_DICTIONARY} 
    ${BASE4_DICTIONARY} 
   ) 

set_source_files_properties(${METAUTILS_DICTIONARY} GENERATED)
set_source_files_properties(${CLIB_DICTIONARY} GENERATED)
set_source_files_properties(${CONT_DICTIONARY} GENERATED)
set_source_files_properties(${TEXTINPUT_DICTIONARY} GENERATED)
set_source_files_properties(${META_DICTIONARY} GENERATED)
if(UNIX)
  set_source_files_properties(${UNIX_DICTIONARY} GENERATED)
endif()
if(WIN32)
  set_source_files_properties(${WINNT_DICTIONARY} GENERATED)
endif()
if(cocoa)
  set_source_files_properties(${MACOSX_DICTIONARY} GENERATED)
endif()
set_source_files_properties(${BASE1_DICTIONARY} GENERATED)
set_source_files_properties(${BASE2_DICTIONARY} GENERATED)
set_source_files_properties(${BASE3_DICTIONARY} GENERATED)
set_source_files_properties(${BASE4_DICTIONARY} GENERATED)

set_source_files_properties(${TEXTINPUT_CXX_SOURCES} PROPERTIES
                             COMPILE_FLAGS -I${CMAKE_SOURCE_DIR}/core/textinput/src )


set_source_files_properties(${CMAKE_SOURCE_DIR}/core/base/src/TPRegexp.cxx
                            ${BASE1_DICTIONARY} ${BASE2_DICTIONARY}
                            COMPILE_FLAGS -I${PCRE_INCLUDE_DIR}
                           )
set_source_files_properties(${CMAKE_SOURCE_DIR}/core/lzma/src/ZipLZMA.c
                            COMPILE_FLAGS -I${LZMA_INCLUDE_DIR}
                           )

if(${GCC_MAJOR} EQUAL 4 AND ${GCC_MINOR} EQUAL 1)
  set_source_files_properties(${CMAKE_SOURCE_DIR}/core/base/src/TString.cxx
                              ${CMAKE_SOURCE_DIR}/core/base/src/TContextMenu.cxx
                              COMPILE_FLAGS -Wno-strict-aliasing
                             )
endif()

if(${ROOT_ARCHITECTURE} MATCHES linuxicc)
  set_source_files_properties(${BASE3_DICTIONARY} 
                              COMPILE_FLAGS -wd191)
endif()


set(INCLUDE_DIRECTORIES 
    ${CMAKE_SOURCE_DIR}/core/metautils/inc 
    ${CMAKE_SOURCE_DIR}/core/meta/inc 
    ${CMAKE_SOURCE_DIR}/core/cont/inc 
    ${CMAKE_SOURCE_DIR}/core/unix/inc 
    ${CMAKE_SOURCE_DIR}/graf3d/g3d/inc
    ${CMAKE_SOURCE_DIR}/net/net/inc
    ${CMAKE_SOURCE_DIR}/core/base/src 
    ${ROOT_INCLUDE_DIR} ) 

ROOT_GENERATE_ROOTMAP(Core LINKDEF ${LibCore_LINKDEF})

include_directories( ${INCLUDE_DIRECTORIES})

if(WIN32)
   set(corelinklibs shell32.lib WSock32.lib Oleaut32.lib Iphlpapi.lib)
elseif(cocoa)
   set(corelinklibs "-framework Cocoa")
endif()

#---Add flags to compile ObjC++
foreach(src ${LibCore_SRCS})
  if(${src} MATCHES "\\.mm$")
    set_source_files_properties(${src} COMPILE_FLAGS "-ObjC++")
  endif()
endforeach()


ROOT_LINKER_LIBRARY(Core ${LibCore_SRCS} ${CORE_DICTIONARIES} 
                    LIBRARIES ${PCRE_LIBRARIES} ${LZMA_LIBRARIES} ${ZLIB_LIBRARY} ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT} ${corelinklibs}
                    DEPENDENCIES Cint)
add_Dependencies(Core CLIB_DICTIONARY CONT_DICTIONARY  META_DICTIONARY METAUTILS_DICTIONARY BASE_DICTIONARY)
if(UNIX)
  add_dependencies(Core UNIX_DICTIONARY)
endif()
if(WIN32)
  add_dependencies(Core WINNT_DICTIONARY)
endif()
if(cocoa)
  add_dependencies(Core MACOSX_DICTIONARY)
endif()
add_dependencies(Core TEXTINPUT_DICTIONARY)
if(builtin_pcre)
  add_dependencies(Core PCRE)
endif()
if(builtin_lzma)
  ROOT_ADD_BUILTIN_DEPENDENCIES(Core LZMA)
endif()

=== geom/CMakeLists.txt ===
add_subdirectory (geom)        # special CMakeLists.txt
add_subdirectory (geombuilder) # special CMakeLists.txt
add_subdirectory (geompainter) # special CMakeLists.txt
if(gdml)
  add_subdirectory(gdml)
  if(NOT gnuinstall)
    install(DIRECTORY gdml/ DESTINATION geom/gdml
            FILES_MATCHING PATTERN "*.py"
            PATTERN "inc" EXCLUDE
            PATTERN "src" EXCLUDE)
  endif()
endif()

=== graf2d/CMakeLists.txt ===
ROOT_USE_PACKAGE(graf2d/gpad)
ROOT_USE_PACKAGE(graf2d/graf)

if(builtin_freetype)
  add_subdirectory(freetype)
endif()
add_subdirectory(gpad)
add_subdirectory(graf)
add_subdirectory(postscript)
add_subdirectory(mathtext)
if(WIN32)
  add_subdirectory(win32gdk)
elseif(x11)
  add_subdirectory(x11)         # special CMakeLists.txt
  add_subdirectory(x11ttf)      # special CMakeLists.txt
endif()
if(asimage)
  add_subdirectory(asimage)     # special CMakeLists.txt
endif()
if(qt)
  add_subdirectory(qt)
endif()
if(gviz)
  add_subdirectory(gviz)
endif()
if(fitsio)
  add_subdirectory(fitsio)
endif()
if(cocoa)
  add_subdirectory(quartz)
  add_subdirectory(cocoa)
endif()

=== graf3d/CMakeLists.txt ===
add_subdirectory(g3d) # special CMakeLists.txt
if(NOT WIN32 AND x11)
  add_subdirectory(x3d) # special CMakeLists.txt
endif()
if (opengl)
   add_subdirectory(eve) # special CMakeLists.txt
   add_subdirectory(gl) # special CMakeLists.txt
   if(builtin_glew)
      add_subdirectory(glew)
   endif()
   if(builtin_ftgl)
      add_subdirectory(ftgl)
   endif()
  add_subdirectory(gviz3d) # special CMakeLists.txt
endif()

=== hist/CMakeLists.txt ===
Add_Subdirectory(hist)             # special CMakeLists.txt
Add_Subdirectory(histpainter)      # special CMakeLists.txt
Add_Subdirectory(spectrum)
Add_Subdirectory(spectrumpainter)  # special CMakeLists.txt
If(CMAKE_Fortran_COMPILER)
  Add_Subdirectory(hbook)
EndIf(CMAKE_Fortran_COMPILER)

=== html/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building ROOT html package
############################################################################

ROOT_USE_PACKAGE(graf2d/gpad)
ROOT_USE_PACKAGE(core/thread)

ROOT_STANDARD_LIBRARY_PACKAGE(Html DEPENDENCIES Graf Thread)

=== main/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building ROOT main package
# @author Pere Mato, CERN
############################################################################

ROOT_USE_PACKAGE(io/io)
ROOT_USE_PACKAGE(tree/tree)
ROOT_USE_PACKAGE(core/rint)

if(NOT WIN32)
  ROOT_EXECUTABLE(rootn.exe rmain.cxx LIBRARIES New Core Cint MathCore Rint)
  ROOT_EXECUTABLE(roots.exe roots.cxx LIBRARIES Core Cint MathCore)
  ROOT_EXECUTABLE(ssh2rpd ssh2rpd.cxx ${CMAKE_SOURCE_DIR}/core/clib/src/strlcpy.c )
endif()
ROOT_EXECUTABLE(root.exe rmain.cxx LIBRARIES Core Cint MathCore Rint)
ROOT_EXECUTABLE(proofserv.exe pmain.cxx LIBRARIES Core Cint MathCore)
ROOT_EXECUTABLE(hadd hadd.cxx LIBRARIES Core Cint RIO Net Hist Graf Graf3d Gpad Tree Matrix MathCore Thread)

if(CMAKE_Fortran_COMPILER)
  if(MSVC)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /SAFESEH:NO ")
    link_directories($ENV{LIB})
  endif()
  if(NOT WIN32)
    ROOT_EXECUTABLE(g2root g2root.f LIBRARIES minicern)
  endif()
  ROOT_EXECUTABLE(h2root h2root.cxx LIBRARIES Core Cint RIO Net Hist Graf Graf3d Gpad Tree Matrix MathCore Thread minicern)
endif()

=== math/CMakeLists.txt ===
ROOT_USE_PACKAGE(math/mathcore)
ROOT_USE_PACKAGE(math/matrix)

add_subdirectory(mathcore)
if(mathmore)
  add_subdirectory(mathmore)
endif()
add_subdirectory(matrix)
add_subdirectory(minuit)
if(minuit2)
  add_subdirectory(minuit2)
endif()  
add_subdirectory(fumili)
add_subdirectory(physics)
add_subdirectory(mlp)
add_subdirectory(quadp)
add_subdirectory(foam)
add_subdirectory(smatrix)
add_subdirectory(splot)
#add_subdirectory(mathcore/test EXCLUDE_FROM_ALL)
add_subdirectory(genvector)
if(tmva) 
  add_subdirectory(genetic) 
endif()
if(unuran)
  add_subdirectory(unuran)
endif()
if(fftw3)
  add_subdirectory(fftw)
endif()
if(vc)
  if(testing)
    set(vc_tests ON)
  endif()
  set(TARGET_ARCHITECTURE auto CACHE STRING "")
  add_subdirectory(vc)
endif()

if(vdt)
  add_subdirectory(vdt)
endif()

=== debian/changelog ===
root-system (5.34.30-0ubuntu8) xenial; urgency=medium

  * Rebuild against libmysqlclient20.

 -- Robie Basak <robie.basak@ubuntu.com>  Tue, 05 Apr 2016 13:00:52 +0000

root-system (5.34.30-0ubuntu7) xenial; urgency=medium

  * No-change rebuild for ruby2.3-only support.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 13 Mar 2016 21:15:34 +0000

root-system (5.34.30-0ubuntu6) xenial; urgency=medium

  * Rebuild against new gsl SONAME change.

 -- Michael Terry <mterry@ubuntu.com>  Tue, 08 Dec 2015 12:07:32 -0500

root-system (5.34.30-0ubuntu5) xenial; urgency=medium

  * Update for gsl_multifit_covar API changes in gsl2.

 -- Iain Lane <iain@orangesquash.org.uk>  Wed, 11 Nov 2015 21:55:45 +0000

root-system (5.34.30-0ubuntu4) xenial; urgency=medium

  * Rebuild against new gsl. Update references to libgsl0-dev to libgsl-
    dev.

 -- Iain Lane <iain@orangesquash.org.uk>  Tue, 10 Nov 2015 15:07:53 +0000

root-system (5.34.30-0ubuntu3) wily; urgency=medium

  * Fix the ARM32 build.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 14 Aug 2015 17:24:44 +0200

root-system (5.34.30-0ubuntu2) wily; urgency=medium

  * Fix configury on powerpc and ppc64el.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 14 Aug 2015 13:46:57 +0200

root-system (5.34.30-0ubuntu1) wily; urgency=medium

  * New upstream version, to build with GCC 5.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 14 Aug 2015 13:04:20 +0200

root-system (5.34.19+dfsg-1.2build1) wily; urgency=medium

  * No-change rebuild against libpytha8v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 12 Aug 2015 19:24:57 +0000

=== debian/control ===
Source: root-system
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Lifeng Sun <lifongsun@gmail.com>
Homepage: http://root.cern.ch
Build-Depends: debhelper (>= 5.0.37.2), lsb-release, autotools-dev, po-debconf, libssl-dev, comerr-dev, libxpm-dev, libltdl-dev, x11proto-xext-dev, libxext-dev, libfreetype6-dev, libpcre3-dev, zlib1g-dev | libz-dev, liblzma-dev, python-dev (>= 2.1), graphviz, ttf-freefont, libncurses5-dev, libgraphviz-dev, libavahi-core-dev, libsqlite3-dev, libxft-dev, dh-python, ruby, ruby-dev, libglu1-mesa-dev| xlibmesa-glu-dev |  libglu-dev, libglew-dev, libftgl-dev, libgl2ps-dev, libxml2-dev, libgsl-dev, libavahi-compat-libdnssd-dev, libldap2-dev | libldap-dev, libjpeg-dev, libpng12-dev, libtiff-dev, libafterimage-dev, libgif-dev, libxinerama-dev, libfftw3-dev | fftw3-dev, libpythia8-dev, libglobus-gss-assist-dev, libglobus-gsi-credential-dev, libglobus-common-dev, libglobus-gsi-sysconfig-dev, libglobus-gssapi-gsi-dev, libglobus-gsi-callback-dev, libglobus-gsi-cert-utils-dev, libglobus-openssl-module-dev, libglobus-gsi-proxy-core-dev, libglobus-callout-dev, globus-proxy-utils,krb5-user|heimdal-clients, libmysqlclient-dev, libiodbc2-dev | unixodbc-dev,  libpq-dev, gfortran|fortran-compiler, libqt4-dev (>= 4.3.0) | libqt3-mt-dev (>= 3.3.0), qt4-dev-tools (>= 4.3.0) | qt3-dev-tools (>= 3.3.0), libqt4-opengl-dev, libkrb5-dev|heimdal-dev
Standards-Version: 3.9.5
Vcs-Git: git://anonscm.debian.org/debian-science/packages/root-system.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/root-system.git

Package: root-system
Architecture: all
Depends: root-system-bin, libroot-core-dev, ${misc:Depends}
Recommends: libroot-graf3d-gl-dev (>= ${binary:Version}), libroot-io-xmlparser-dev (>= ${binary:Version}), libroot-math-mathmore-dev (>= ${binary:Version}), libroot-math-unuran-dev (>= ${binary:Version}), libroot-misc-memstat-dev (>= ${binary:Version}), libroot-misc-table-dev (>= ${binary:Version}), libroot-net-bonjour-dev (>= ${binary:Version}), libroot-net-ldap-dev (>= ${binary:Version}), root-plugin-graf2d-asimage (>= ${binary:Version}), root-plugin-gui-qt (>= ${binary:Version}), root-plugin-graf2d-qt (>= ${binary:Version}), root-plugin-math-fftw3 (>= ${binary:Version}), root-plugin-math-minuit2 (>= ${binary:Version}), root-plugin-net-krb5 (>= ${binary:Version}), root-plugin-sql-odbc (>= ${binary:Version}), libroot-geom-dev (>= ${binary:Version}), libroot-graf2d-gpad-dev (>= ${binary:Version}), libroot-graf2d-graf-dev (>= ${binary:Version}), libroot-graf2d-postscript-dev (>= ${binary:Version}), libroot-graf3d-eve-dev (>= ${binary:Version}), libroot-graf3d-g3d-dev (>= ${binary:Version}), libroot-gui-dev (>= ${binary:Version}), libroot-gui-ged-dev (>= ${binary:Version}), libroot-hist-dev (>= ${binary:Version}), libroot-hist-spectrum-dev (>= ${binary:Version}), libroot-html-dev (>= ${binary:Version}), libroot-io-dev (>= ${binary:Version}), libroot-math-foam-dev (>= ${binary:Version}), libroot-math-genvector-dev (>= ${binary:Version}), libroot-math-mathcore-dev (>= ${binary:Version}), libroot-math-matrix-dev (>= ${binary:Version}), libroot-math-minuit-dev (>= ${binary:Version}), libroot-math-mlp-dev (>= ${binary:Version}), libroot-math-physics-dev (>= ${binary:Version}), libroot-math-quadp-dev (>= ${binary:Version}), libroot-math-smatrix-dev (>= ${binary:Version}), libroot-math-splot-dev (>= ${binary:Version}), libroot-misc-minicern-dev (>= ${binary:Version}), libroot-montecarlo-eg-dev (>= ${binary:Version}), libroot-montecarlo-vmc-dev (>= ${binary:Version}), libroot-net-dev (>= ${binary:Version}), libroot-net-auth-dev (>= ${binary:Version}), libroot-proof-dev (>= ${binary:Version}), libroot-proof-proofplayer-dev (>= ${binary:Version}), libroot-tmva-dev (>= ${binary:Version}), libroot-tree-dev (>= ${binary:Version}), libroot-tree-treeplayer-dev (>= ${binary:Version}), root-plugin-geom-geombuilder (>= ${binary:Version}), root-plugin-geom-geompainter (>= ${binary:Version}), root-plugin-graf2d-x11 (>= ${binary:Version}), root-plugin-graf3d-x3d (>= ${binary:Version}), root-plugin-gui-fitpanel (>= ${binary:Version}), root-plugin-gui-guibuilder (>= ${binary:Version}), root-plugin-gui-sessionviewer (>= ${binary:Version}), root-plugin-hist-hbook (>= ${binary:Version}), root-plugin-hist-histpainter (>= ${binary:Version}), root-plugin-hist-spectrumpainter (>= ${binary:Version}), root-plugin-io-sql (>= ${binary:Version}), root-plugin-io-xml (>= ${binary:Version}), root-plugin-math-fumili (>= ${binary:Version}), root-plugin-tree-treeviewer (>= ${binary:Version}), root-system-proofd (>= ${binary:Version}), root-system-rootd (>= ${binary:Version}), root-system-doc  (>= ${binary:Version})
Suggests: libroot-bindings-python-dev (>= ${binary:Version}), libroot-bindings-ruby-dev (>= ${binary:Version}), libroot-roofit-dev (>= ${binary:Version}), root-plugin-geom-gdml (>= ${binary:Version}), root-plugin-montecarlo-pythia8 (>= ${binary:Version}), root-plugin-net-globus (>= ${binary:Version}), root-plugin-sql-mysql (>= ${binary:Version}), root-plugin-sql-pgsql (>= ${binary:Version})
Description: metapackage to install all ROOT packages
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently.
 .
 With the data defined as a set of objects, specialized storage methods
 can give direct access to the separate attributes of the selected
 objects, without having to touch the bulk of the data. Included are
 histogramming methods in 1, 2 and 3 dimensions, curve fitting, function
 evaluation, minimization, graphics and visualization classes to allow the
 easy creation of an analysis system that can query and process the data
 interactively or in batch mode.
 .
 The command language, the scripting (or macro) language, and the   
 programming language are all C++, thanks to the built-in CINT C++    
 interpreter. This interpreter removes the time consuming compile/link
 cycle, allowing for fast prototyping of the macros, and providing a
 good environment to learn C++. If more performance is needed, the
 interactively developed macros can be compiled using a C++ compiler.
 .
 The system has been designed in such a way that it can query its
 databases in parallel on MPP machines or on clusters of workstations
 or high-end PCs. ROOT is an open system that can be dynamically
 extended by linking external libraries. This makes ROOT a premier
 platform on which to build data acquisition, simulation and data
 analysis systems.
 .
 This package is a metapackage to ensure the installation of all
 possible ROOT packages on a system. 
 
Package: libroot-bindings-python5.34
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${python:Depends}, ${misc:Depends}, dh-python
Provides: ${python:Provides}
Replaces: root-plugin-python  (<< 5.09.01-1)
Breaks: libroot-bindings-python-dev (<< 5.34.01-1~exp1)
Description: Python extension for ROOT - runtime libraries 
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the Python plug-in for ROOT.  This package
 provide a Python interface to ROOT, and a ROOT interface to Python.

Package: libroot-bindings-python-dev
Architecture: any
Section: libdevel
Depends: libroot-bindings-python5.34 (= ${binary:Version}), libroot-core-dev, python-dev (>= 2.1), ${python:Depends}, ${misc:Depends} 
Replaces: libroot-python-dev
Breaks: libroot-python-dev (<< 5.19.01-1)
Description: Python extension for ROOT - development files 
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the development files of Python plug-in for ROOT.

Package: libroot-bindings-ruby5.34
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends} 
Replaces: root-plugin-ruby  (<< 5.09.01-1)
Description: Ruby extension for ROOT - run-time library
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the Ruby extension for ROOT.  The interface
 goes both ways - that is, you can call ROOT functions from Ruby, and
 invoke the Ruby interpreter from ROOT. 

Package: libroot-bindings-ruby-dev
Architecture: any
Section: libdevel
Depends: libroot-bindings-ruby5.34 (= ${binary:Version}), libroot-core-dev, ruby1.9.1-dev | ruby-dev (>= 4.9), ${misc:Depends} 
Breaks: libroot-ruby (<< 5.19.01-1)
Replaces: libroot-ruby
Description: Ruby extension for ROOT - development headers
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the Ruby extension for ROOT.

Package: libroot-graf3d-gl5.34
Architecture: any
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: root-plugin-graf3d-gl (<< 5.19.00-1)
Replaces: root-plugin-graf3d-gl (<< 5.19.00-1)
Provides: root-plugin-graf3d-gl
Description: GL plugin for ROOT - runtime library
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the GL plug-in for ROOT.  This plugin provides
 3D rendering of volumes and shapes defined in ROOT, as well as 3D 
 rendering of histograms, and similar.  Included is also a high quality 
 3D viewer for ROOT defined geometries.

Package: libroot-graf3d-gl-dev
Architecture: any
Section: libdevel
Depends: libroot-graf3d-gl5.34 (= ${binary:Version}), libgl2ps-dev, ${misc:Depends}
Breaks: root-plugin-graf3d-gl (<< 5.19.00-1)
Replaces: root-plugin-graf3d-gl
Description: GL plugin for ROOT - development files
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the GL plug-in for ROOT.  This plugin provides
 3D rendering of volumes and shapes defined in ROOT.  Included is also
 a high quality 3D viewer for ROOT defined geometries.

Package: libroot-io-xmlparser5.34
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: XML parser of ROOT objects - runtime library
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package provides XML parser routines for ROOT objects.

Package: libroot-io-xmlparser-dev
Architecture: any
Section: libdevel
Depends: libroot-io-xmlparser5.34 (= ${binary:Version}), libroot-core-dev, ${misc:Depends}
Replaces: libroot-dev, root-plugin-xml
Breaks: libroot-dev (<< 5.19.01-1), root-plugin-xml (<< 5.19.01-1)
Description: XML parser of ROOT objects - development files
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package provides development files of XML parser routines for ROOT
 objects.

Package: libroot-math-mathmore5.34
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GSL interface library for ROOT

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

PREFIX		= /usr
SYSCONFDIR	= /etc

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE    ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH_CPU    ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
DEB_HOST_ARCH	     ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_BUILD_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_BUILD_GNU_SYSTEM ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_SYSTEM)
DEB_BUILD_ARCH	     ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS   := $(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)
EXTRA_LDFLAGS  := $(LDFLAGS)

ifeq ($(DEB_HOST_ARCH),ppc64el)
  CFLAGS := $(subst -O3,-O2,$(CFLAGS))
endif

export CFLAGS EXTRA_LDFLAGS DEB_HOST_MULTIARCH

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
BUILDOPT	= --build=debug
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
INSTALL_PROGRAM = -s
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
MAKEFLAGS += -j$(NUMJOBS)
endif
ifeq (hurd-i386,$(DEB_BUILD_ARCH))
MAKEFLAGS += -j1
endif
UNUR		= --enable-unuran
#ifneq (,$(findstring alpha, $(DEB_BUILD_ARCH)))
#UNUR		= --disable-unuran
#endif
#XRD		= --enable-xrootd
#ifneq (,$(findstring sparc, $(DEB_BUILD_ARCH)))
XRD		= --disable-xrootd
#endif

DTMP		= debian/tmp
PKGDOCDIR	= $(PREFIX)/share/doc/root
CINTDIR		= $(PREFIX)/lib/$(DEB_HOST_MULTIARCH)/root$(SOVERS)
ICONTHEME	= $(PREFIX)/share/icons/hicolor/48x48
CONFOPTIONS	:=--enable-bonjour				\
		  --enable-cintex				\
		  --enable-editline				\
		  --enable-explicitlink				\
		  --enable-gdml					\
		  --enable-globus				\
		  --enable-gsl-shared				\
		  --disable-gviz				\
		  --enable-fftw3				\
		  --enable-krb5					\
		  --enable-ldap					\
		  --enable-qt					\
		  --enable-qtgsi				\
		  --enable-mathcore				\
		  --enable-mathmore				\
		  --enable-memstat				\
		  --enable-minuit2				\
		  --enable-mysql				\
		  --enable-pgsql				\
		  --enable-pythia8				\
		  --enable-odbc					\
		  --enable-reflex				\
		  --enable-roofit				\
		  --enable-ruby					\
		  --enable-shadowpw				\
		  --enable-shared				\
		  --enable-soversion				\
		  --enable-sqlite				\
		  --enable-table				\
		  --disable-rpath				\
		  --disable-afs					\
		  --disable-srp					\
		  --disable-builtin-afterimage			\
		  --disable-builtin-ftgl			\
		  --disable-builtin-freetype			\
		  --disable-builtin-glew			\
		  --disable-builtin-pcre			\
		  --disable-builtin-zlib			\
		  --disable-builtin-lzma			\
		  --disable-alien				\
		  --disable-chirp				\
		  --disable-dcache				\
		  --disable-gfal				\
		  --disable-monalisa				\
		  --disable-oracle				\
		  --disable-pythia6				\
		  --disable-rfio				\
		  --disable-sapdb				\
		  --fail-on-missing				\
		  --with-globus=/usr				\
		  --with-globus-incdir=/usr/include/globus	\
		  --with-globus-libdir=/usr/lib			\
		  --with-odbc-incdir=/usr/include/iodbc		\
		  --with-pythia8-incdir=/usr/include/pythia8	\
		  $(UNUR)					\
		  $(XRD)					\
		  $(BUILDOPT)
#
# Things for the future 
#
#		  --enable-mathcore	libroot
#		  --enable-cintex	libroot
#		  --enable-reflex	libroot
#		  --with-globus=/opt/globus
#		  --disable-builtin-gsl				
#		  --disable-builtin				\

VERSION		:= $(shell head -n1 debian/changelog | cut -d' ' -f2 | tr -d '()')
MAJOR		:= $(shell echo $(VERSION) | cut -f1 -d'.')
MINOR		:= $(shell echo $(VERSION) | cut -f2 -d'.')
SOVERS		:= $(MAJOR).$(MINOR)
PKGLIST		:= $(shell ./configure $(PLATFORM) --pkglist $(CONFOPTIONS) | sed -n -e 's/packages: //p')
ESSENTIALS	:= libroot-core-dev			\
		   libroot-core				\
		   root-system-bin			\
		   root-system-common			\
		   ttf-root-installer		
PLUGINS		:= libroot-geom				\
		   libroot-graf2d-gpad			\
		   libroot-graf2d-graf			\
		   libroot-graf2d-postscript		\
		   libroot-graf3d-eve			\
		   libroot-graf3d-g3d			\
		   libroot-graf3d-gl			\
		   libroot-gui				\
		   libroot-gui-ged			\
		   libroot-hist				\
		   libroot-hist-spectrum		\
		   libroot-html				\
		   libroot-io				\
		   libroot-io-xmlparser			\
		   libroot-math-foam			\
		   libroot-math-genvector		\
		   libroot-math-mathcore		\
		   libroot-math-mathmore		\
		   libroot-math-matrix			\
		   libroot-math-minuit			\
		   libroot-math-mlp			\
		   libroot-math-quadp			\
		   libroot-math-physics			\
		   libroot-math-smatrix			\
		   libroot-math-splot			\
		   libroot-math-unuran			\
		   libroot-misc-minicern		\
		   libroot-misc-memstat			\
		   libroot-misc-table			\
		   libroot-montecarlo-eg		\
		   libroot-montecarlo-vmc		\
		   libroot-net				\
		   libroot-net-auth			\
		   libroot-net-bonjour			\
		   libroot-net-ldap			\
		   libroot-proof			\
		   libroot-proof-proofplayer		\
		   libroot-tmva				\
		   libroot-tree				\
		   libroot-tree-treeplayer		\
		   root-plugin-geom-geombuilder		\
		   root-plugin-geom-geompainter		\
		   root-plugin-graf2d-asimage		\
		   root-plugin-graf2d-qt		\
		   root-plugin-graf2d-x11		\
		   root-plugin-graf2d-gvi		\
		   root-plugin-graf3d-x3d		\
		   root-plugin-gui-fitpanel		\
		   root-plugin-gui-guibuilder		\
		   root-plugin-gui-qt			\
		   root-plugin-gui-sessionviewer	\
		   root-plugin-hist-hbook		\
		   root-plugin-hist-histpainter		\
		   root-plugin-hist-spectrumpainter	\
		   root-plugin-io-sql			\
		   root-plugin-io-xml			\
		   root-plugin-math-fftw3		\
		   root-plugin-math-fumili		\
		   root-plugin-math-minuit2		\
		   root-plugin-net-krb5			\
		   root-plugin-net-netx			\
		   root-plugin-sql-odbc			\
		   root-plugin-tree-treeviewer		\
		   root-system-proofd			\
		   root-system-doc			\
		   root-system-rootd
#		   root-plugin-graf2d-gviz
EXTRAS		:= libroot-bindings-python		\
		   libroot-roofit			\
		   libroot-bindings-ruby		\
		   root-plugin-geom-gdml		\
		   root-plugin-io-castor		\
		   root-plugin-io-chirp			\
		   root-plugin-io-dcache		\
		   root-plugin-montecarlo-pythia8	\
		   root-plugin-net-globus		\
		   root-plugin-net-bonjour		\
		   root-plugin-net-alien		\
		   root-plugin-net-srp			\
		   root-plugin-sql-maxdb		\
		   root-plugin-sql-mysql		\
		   root-plugin-sql-oracle		\
		   root-plugin-sql-pgsql		
PLUGINLIST	:= $(filter-out $(EXTRAS) $(ESSENTIALS), $(PKGLIST))
EXTRALIST	:= $(filter-out $(PLUGINS) $(ESSENTIALS), $(PKGLIST))
PLUGINLIST	:= $(PLUGINLIST:libroot%=libroot%-dev)
EXTRALIST	:= $(EXTRALIST:libroot%=libroot%-dev)
PLUGINHEAD	:= $(filter-out $(lastword $(PLUGINLIST)), $(PLUGINLIST))
PLUGINLIST	:= $(PLUGINHEAD:%=%,) $(lastword $(PLUGINLIST))
EXTRAHEAD	:= $(filter-out $(lastword $(EXTRALIST)), $(EXTRALIST))
EXTRALIST	:= $(EXTRAHEAD:%=%,) $(lastword $(EXTRALIST))
TEMPLATES	:= $(wildcard debian/skel/*.links.in) \
                   $(wildcard debian/skel/*.menu.in) \
                   $(wildcard debian/skel/*.prerm.in) \
                   $(wildcard debian/skel/*.preinst.in) \
                   $(wildcard debian/skel/*.postinst.in) \
                   $(wildcard debian/skel/*.init.in) \
                   $(wildcard debian/skel/*.desktop.in)
SPKGLIST	:= $(filter-out root-system-doc root-system-common ttf-root-installer, $(PKGLIST:libroot%=libroot%$(SOVERS))) $(filter libroot%, $(PKGLIST:libroot%=libroot%-dev)) libroot-static
IPKGLIST	:= root-system-doc ttf-root-installer root-system-common root-system
DPKGLIST	:= $(SPKGLIST:%=%,) root-system-doc, root-ttf
#root-plugins root-extra-plugins
SPKGOPTS	:= $(SPKGLIST:%=-p%) 
IPKGOPTS	:= $(IPKGLIST:%=-p%) 
PKGOPTS		:= $(IPKGOPTS) $(SPKGOPTS)
HAVERUBY	:= $(filter libroot-bindings-ruby, $(PKGLIST))
ifeq ($(HAVERUBY), libroot-bindings-ruby)
